/* $Id: putimage.c,v 1.5 2006/01/28 16:46:10 cegger Exp $
***************************************************************************

   X server for LibGGI - GC (graphics context) acceleration

   Copyright (C) 1997      Michael Krause	[rawstyle@ms.demo.org]
   Copyright (C) 1998-2000 Marcus Sundberg	[marcus@ggi-project.org]
   Copyright (C) 2003-2006 Christoph Egger

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

***************************************************************************
*/


#include "gc.h"


void xggiPutImage(DrawablePtr pDrawable,
		     GCPtr pGC, int depth,
		     int x, int y,
		     int w, int h,
		     int leftPad, int format,
		     char *pBits)
{
	XGGI_GC_OP_PROLOGUE(pGC, pDrawable);

	if (!w || !h) return;

	if ((format == ZPixmap)
	  && ((pGC->alu == GXcopy) || (pGC->alu == GXset))
	  && (DRAWABLE_HAS_MASTER_VISUAL_BPP(pDrawable, scr))
	  && (MASTER_VISUAL_BPP(scr) == depth)
	/* only works in 32bit mode. Pity */
	  && (MASTER_VISUAL_BPP(scr) == 32))
	{
		DBUF_PROLOGUE(scr);

		ggiPutBox(MASTER_VISUAL_VIS(scr),
			x + pDrawable->x, y + pDrawable->y,
			w, h, (void *) (pBits));

		DBUF_EPILOGUE(scr);
		XGGI_GC_OP_EPILOGUE(pGC, pDrawable);
		return;
	}	/* if */


	pGC->ops->PutImage(pDrawable, pGC,
			depth, x, y, w, h,
			leftPad, format, pBits);

	XGGI_GC_OP_EPILOGUE(pGC, pDrawable);
	return;
}	/* xggiPutImage */
